''
'' Fibonacci demo
''

CON
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

VAR
  long hubn
  long hubres
  long hubcnt

OBJ
  fds : "FullDuplexSerial.spin"

PUB run | i,x,now,elapsed

  '' start up the serial port
  fds.start(31, 30, 0, 115200)

  '' start up the cog helper
  hubn := 0
  cognew(@entry, @hubn)

  '' and say hello
  repeat i from 1 to 15
    x := pasmfibo(i)
    elapsed := hubcnt
    fds.str(string("fibo("))
    fds.dec(i)
    fds.str(string(") = "))
    fds.dec(x)
    fds.str(string("  time taken: "))
    fds.dec(elapsed)
    fds.str(string(" cycles ("))
    fds.dec(elapsed/80000)
    fds.str(string(" ms)", 13, 10))
  '' now just hang
  fds.str(string("done", 13, 10))
  repeat

PUB pasmfibo(x)
  hubcnt := 0
  hubn := x
  repeat while (hubn <> 0)
  return hubres

DAT
	org
entry
	mov	inpptr,par
	mov	resptr,par
	add	resptr,#4
	mov	cntptr,resptr
	add	cntptr,#4
	mov	sp, #stack
	'' wait for non-zero input
:waitin
	rdlong	n, inpptr wz
  if_z  jmp	#:waitin

  	neg	telapsed,cnt
  	call	#Fibo
	add	telapsed,cnt
	mov	n,#0
	wrlong	r, resptr
	wrlong  telapsed,cntptr
	wrlong	n, inpptr	'' indicate we have done
	jmp	#:waitin

	'' calculate Fibo(n)
Fibo
	mov	r,#1
	cmps	n,#2 wz,wc
  if_be	jmp	Fibo_ret

  	mov	top,Fibo_ret
	call	#Push
	sub	n,#1
	mov	top,n
	call	#Push
	call	#Fibo
	call	#Pop
	mov	n,top
	sub	n,#1
	mov	top,r
	call	#Push
	call	#Fibo
	call	#Pop	'' restore previous r
	add	r,top
	call	#Pop	'' restore return address
	jmp	top
Fibo_ret
	ret

	'' push "top" onto stack
Push
	movd	:psh,sp
	add	sp,#1
:psh	mov	0-0, top
Push_ret
	ret

	'' pop "top" from stack
Pop
	sub	sp,#1
	movs	:popi,sp
	nop
:popi	mov	top,0-0
Pop_ret
	ret

inpptr	res	1	' points to input n in hub ram
resptr	res	1	' points to result in hub memory
cntptr  res	1	' points to elapsed time in hub memory
telapsed res	1	' used to time elapsed ticks
n	res	1	' input for Fibo
r	res	1	' output for Fibo
sp	res	1	' stack pointer
top	res	1	' top of stack
stack	res	100	' stack
